// Mutexe fuer Inter-Prozess-Synchronisation
// Betriebssysteme 1, Hans-Georg Esser, FH SWF

#include <stdio.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>

#define FILENAME "./countme.dat"
#define LOCKFNAME "./countme.lck"
#define WIE_OFT 1000
#define FORTYTWO 42

int lockfd;  // File Descriptor fuer Lock-Datei

void initnum (int num) {
  // Daten-Datei initialisieren
  FILE *handle = fopen (FILENAME, "w");
  fprintf (handle, "%d\n", num);
  fclose (handle);

  // Lock-Datei initialisieren und oeffnen
  lockfd = open (LOCKFNAME, O_RDWR | O_TRUNC | O_CREAT, 0644); 
}

int readnum () {
  int num;
  FILE *handle = fopen (FILENAME, "r");
  fscanf (handle, "%d", &num);
  fclose (handle);
  return num;
}

void incnum () {
  int num;
  FILE *handle = fopen (FILENAME, "r+");
  fscanf (handle, "%d", &num);
  rewind (handle);
  fprintf (handle, "%d\n", ++num);
  fclose (handle);
}

void decnum () {
  int num;
  FILE *handle = fopen (FILENAME, "r+");
  fscanf (handle, "%d", &num);
  rewind (handle);
  fprintf (handle, "%d\n", --num);
  fclose (handle);
}

int main () {
  int res, pid, i;
  printf ("Parallele Zaehler mit Dateizugriff\n");
  initnum (FORTYTWO);
  res = readnum (); printf ("num = %d\n", res);

  pid = fork ();
  if (pid == 0) { // Sohn
    for (i=0; i<WIE_OFT; i++) incnum ();
    printf ("%d x incnum: fertig.\n", WIE_OFT);
    exit (0);
  } else {        // Vater
    for (i=0; i<WIE_OFT; i++) decnum ();
    printf ("%d x decnum: fertig.\n", WIE_OFT);
    waitpid (pid, NULL, 0);
  }

  res = readnum (); printf ("num = %d", res);
  if (res != FORTYTWO) 
    printf (" != %d !!\n", FORTYTWO);  // Fehler!
  else 
    printf ("\n");                // kein Fehler.
  exit (0);
}
